function [Q,T,err] = subsit(A, nit, Q) 
%% [Q,R,err] = subsit(A, nit, Q) 
%% does "nit" steps of subspace iteration 
%% (with projection)
%% on return
%% Q   = orth. basis of invariant subspace
%% T   = Q'*A*Q = projection of A on Q.
%% err = norm of A *Q - Q*T  where T = Q'*A*Q.
%%
 for i=1:nit
      [Q1,R] = qr(A*Q,0); 
      [U,T]  = schur(Q1'*A*Q1);
      Q      = Q1*U; 
 end
 err=norm(A*Q - Q*T);

