%%-------------------------------------------------
%% generate a "block " finite difference matrix -- using fd3dB
%% 
%%-------------------------------------------------
Bx = [2 1 -1; 1 2 -1; 0.5 1 2];
Bz = 100*ones(3,3);
nx = 10;
ny = 10; 
nz = 1; 
A = fd3dB(nx,ny,nz,Bx,Bx,Bz) ;   
%% A = fd3d(nx,ny,nz) ;
n = size(A,1) ; 
n = size(A,1);

%%-------------------------------------------------
%% show pattern
%%-------------------------------------------------
%%spy(A)
%% 
%% number of subdomains: 
ndom = 4; 
%%
%% call partitioner 
%% 
[list,ptr,marker] =  rdis(A, ndom) ; 
%%
%% show subdomain sizes : 
%%
sizes = ptr(2:ndom+1) - ptr(1:ndom)
%%
%% show subdomains 
%%
for i=1:ndom
    fprintf(' --\n') 
    fprintf(' domain #  %d \n', i) 
    for j=ptr(i):ptr(i+1)-1 
        fprintf(' %d ', list(j)) 
    end
end 
    fprintf('--\n') 
%% 
%% show permuted matrix
%% 
    B = A(list,list);
    hold off; 
    spy(B)
    hold on                            
    for i=1:ndom-1
      nS = ptr(i+1)-1 ; 
      plot([1,n],[nS+0.5,nS+0.5],'r')   
      plot([nS+0.5,nS+0.5],[1,n],'r')   
   end 
    disp(' .. pausing -- hit a key to continue') 
   pause 
%% 
%%  the above does not separate the interface to the end
%%  the following function will do this: 
%% 
%% 
 [perm,sizes] = separ(A,ndom,marker,list,ptr) ; 
 B = A(perm,perm);
 nS = 0; 
 figure(2) 
 hold off; 
 spy(B) 
 hold on                            
    for i=1:ndom
    nS = nS + sizes(i);
    plot([1,n],[nS+0.5,nS+0.5],'r')   
    plot([nS+0.5,nS+0.5],[1,n],'r')   
 end 


